/****************************************/
/* Javascript Simplelax 2.0             */
/* from D.Yamaoka                       */
/****************************************/

(function($){
	$.fn.simplelax = function(options){
		var option = {
			view: '.parallax-view'
		};
		var appendix = {
			base: 'simplelax-parallax',
			view: 'simplelax-parallax-view',
			reserve: 20
		};
		var config = $.extend(option, options);
		var inc = $(this), win = $(window);

		var module = (function(){
			return{
				init: function(){
					inc.each(function(){
						$(this).addClass(appendix.base);
						$(this).children(config.view).addClass(appendix.view);
					});
					this.set();
					this.roll();
				},
				set: function(){
					inc.each(function(n){
						var view = $(this).children('.' + appendix.view);
						var size = {
							w: win.outerWidth(true) + (appendix.reserve * 2),
							h: win.outerHeight(true) + (appendix.reserve * 2),
							c: config.reserve * -1
						};
						view.css({'marginTop': size.c, 'marginLeft': size.c, 'width': size.w, 'height': size.h, 'zIndex': (n + 1) * -1});
					});
				},
				roll: function(){
					inc.each(function(n){
						var view = $(this).children('.' + appendix.view);
						var top = ($(this).offset().top * -1) + win.scrollTop();
						view.css({'top': top});
					});
				}
			};
		})();

		module.init();
		
		$(window).bind('resize', function(){
			module.set();
			module.roll();
		});
		$(window).bind('scroll', function(){
			module.roll();
		});

		return(this);
	};
})(jQuery);
